Halide 22.0.0 Halide compiler and libraries

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
Halide::Internal::Simplify::ScopedFact Struct Reference

`#include <Simplify_Internal.h>`

## Public Member Functions
void | learn_false (const Expr &fact)
void | learn_true (const Expr &fact)
void | learn_upper_bound (const Variable *v, int64_t val)
void | learn_lower_bound (const Variable *v, int64_t val)
Expr | substitute_facts (const Expr &e)
Stmt | substitute_facts (const Stmt &s)
| ScopedFact (Simplify *s)
| ~ScopedFact ()
| ScopedFact (const ScopedFact &that)=delete
| ScopedFact (ScopedFact &&that)=default

## Public Attributes
Simplify * | simplify
std::vector< const Variable * > | pop_list
std::vector< const Variable * > | bounds_pop_list
std::set< Expr, IRDeepCompare > | truths
std::set< Expr, IRDeepCompare > | falsehoods

## Detailed Description

Definition at line 434 of file Simplify_Internal.h.

## Constructor & Destructor Documentation

## ◆ ScopedFact() [1/3]

Halide::Internal::Simplify::ScopedFact::ScopedFact | ( | Simplify * | s | ) |
| inline

Definition at line 450 of file Simplify_Internal.h.

## ◆ ~ScopedFact()

Halide::Internal::Simplify::ScopedFact::~ScopedFact | ( |  | ) |

## ◆ ScopedFact() [2/3]

Halide::Internal::Simplify::ScopedFact::ScopedFact | ( | const ScopedFact & | that | ) |
| delete

## ◆ ScopedFact() [3/3]

Halide::Internal::Simplify::ScopedFact::ScopedFact | ( | ScopedFact && | that | ) |
| default

## Member Function Documentation

## ◆ learn_false()

void Halide::Internal::Simplify::ScopedFact::learn_false | ( | const Expr & | fact | ) |

Referenced by Halide::Internal::Simplify::scoped_falsehood().

## ◆ learn_true()

void Halide::Internal::Simplify::ScopedFact::learn_true | ( | const Expr & | fact | ) |

Referenced by Halide::Internal::Simplify::scoped_truth().

## ◆ learn_upper_bound()

void Halide::Internal::Simplify::ScopedFact::learn_upper_bound | ( | const Variable * | v,
|  | int64_t | val
| ) |  |

## ◆ learn_lower_bound()

void Halide::Internal::Simplify::ScopedFact::learn_lower_bound | ( | const Variable * | v,
|  | int64_t | val
| ) |  |

## ◆ substitute_facts() [1/2]

Expr Halide::Internal::Simplify::ScopedFact::substitute_facts | ( | const Expr & | e | ) |

## ◆ substitute_facts() [2/2]

Stmt Halide::Internal::Simplify::ScopedFact::substitute_facts | ( | const Stmt & | s | ) |

## Member Data Documentation

## ◆ simplify

Simplify* Halide::Internal::Simplify::ScopedFact::simplify

Definition at line 435 of file Simplify_Internal.h.

## ◆ pop_list

std::vector<const Variable *> Halide::Internal::Simplify::ScopedFact::pop_list

Definition at line 437 of file Simplify_Internal.h.

## ◆ bounds_pop_list

std::vector<const Variable *> Halide::Internal::Simplify::ScopedFact::bounds_pop_list

Definition at line 438 of file Simplify_Internal.h.

## ◆ truths

std::set<Expr, IRDeepCompare> Halide::Internal::Simplify::ScopedFact::truths

Definition at line 439 of file Simplify_Internal.h.

## ◆ falsehoods

std::set<Expr, IRDeepCompare> Halide::Internal::Simplify::ScopedFact::falsehoods

Definition at line 439 of file Simplify_Internal.h.

The documentation for this struct was generated from the following file:

- src/Simplify_Internal.h